-- Update Time
local UPDATEPERIOD, elapsed = 1, 0

-- Load Libraries
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

-- Data Objects

-- Basic Stats
local Haste_Frame = ldb:NewDataObject("StatsNow - Haste", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Druid_Dash"})
local Dodge_Frame = ldb:NewDataObject("StatsNow - Dodge", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Shadow_ShadowWard"})
local Parry_Frame = ldb:NewDataObject("StatsNow - Parry", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Parry"})
local Block_Frame = ldb:NewDataObject("StatsNow - Block", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Defend"})
local Hit_Frame = ldb:NewDataObject("StatsNow - Hit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_ChargePositive"})
local Resilience_Frame = ldb:NewDataObject("StatsNow - Resilience", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_ChargeNegative"})

-- Melee/Range Stats
local Melee_AP_Frame = ldb:NewDataObject("StatsNow - Melee Attack Power", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_MeleeDamage"})
local Melee_Crit_Frame = ldb:NewDataObject("StatsNow - Melee Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Warrior_ShieldBreak"})
local Expertise_Frame = ldb:NewDataObject("StatsNow - Expertise", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Warrior_Challange"})
local Armor_Pen_Frame = ldb:NewDataObject("StatsNow - Armor Penetration", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Hunter_PiercingShots"})
local Range_AP_Frame = ldb:NewDataObject("StatsNow - Range Attack Power", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Hunter_MasterMarksman"})
local Range_Crit_Frame = ldb:NewDataObject("StatsNow - Range Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Ability_Hunter_Assassinate2"})

-- Spell Power Stats
local Arcane_SP_Frame = ldb:NewDataObject("StatsNow - Arcane Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Arcane_Blast"})
local Arcane_Crit_Frame = ldb:NewDataObject("StatsNow - Arcane Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Arcane_Rune"})
local Nature_SP_Frame = ldb:NewDataObject("StatsNow - Nature Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Nature_Lightning"})
local Nature_Crit_Frame = ldb:NewDataObject("StatsNow - Nature Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Nature_LightningOverload"})
local Fire_SP_Frame = ldb:NewDataObject("StatsNow - Fire Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Fire_FireBall02"})
local Fire_Crit_Frame = ldb:NewDataObject("StatsNow - Fire Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Fire_FireBall"})
local Frost_SP_Frame = ldb:NewDataObject("StatsNow - Frost Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Frost_FrostBolt02"})
local Frost_Crit_Frame = ldb:NewDataObject("StatsNow - Frost Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Frost_WizardMark"})
local Holy_SP_Frame = ldb:NewDataObject("StatsNow - Holy Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Holy_FlashHeal"})
local Holy_Crit_Frame = ldb:NewDataObject("StatsNow - Holy Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Holy_HolyBolt"})
local Shadow_SP_Frame = ldb:NewDataObject("StatsNow - Shadow Dmg", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Shadow_DeathCoil"})
local Shadow_Crit_Frame = ldb:NewDataObject("StatsNow - Shadow Crit", {type = "data source", text = "", icon = "Interface\\Icons\\Spell_Shadow_ShadowWordPain"})

-- Frames
local Haste = CreateFrame("frame")
local Dodge = CreateFrame("frame")
local Parry = CreateFrame("frame")
local Block = CreateFrame("frame")
local Hit = CreateFrame("frame")
local Resilience = CreateFrame("frame")

local Melee_AP = CreateFrame("frame")
local Melee_Crit = CreateFrame("frame")
local Expertise = CreateFrame("frame")
local Armor_Pen = CreateFrame("frame")
local Range_AP = CreateFrame("frame")
local Range_Crit = CreateFrame("frame")

local Arcane_DMG = CreateFrame("frame")
local Arcane_CRIT = CreateFrame("frame")
local Nature_DMG = CreateFrame("frame")
local Nature_CRIT = CreateFrame("frame")
local Fire_DMG = CreateFrame("frame")
local Fire_CRIT = CreateFrame("frame")
local Frost_DMG = CreateFrame("frame")
local Frost_CRIT = CreateFrame("frame")
local Holy_DMG = CreateFrame("frame")
local Holy_CRIT = CreateFrame("frame")
local Shadow_DMG = CreateFrame("frame")
local Shadow_CRIT = CreateFrame("frame")

-- Data Input
Arcane_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Arcane = GetSpellBonusDamage("7")
	Arcane_SP_Frame.text = "Arcane Dmg: "..SP_Arcane
end)

Arcane_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Arcane_Crit = GetSpellCritChance("7")
	Arcane_Crit_Frame.text = string.format("Arcane Crit: %.2f%%", SP_Arcane_Crit)
end)

Nature_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Nature = GetSpellBonusDamage("4")
	Nature_SP_Frame.text = "Nature Dmg: "..SP_Nature
end)

Nature_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Nature_Crit = GetSpellCritChance("4")
	Nature_Crit_Frame.text = string.format("Nature Crit: %.2f%%", SP_Nature_Crit)
end)

Haste:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Haste = GetCombatRatingBonus("20")
	Haste_Frame.text = string.format("Haste: %.2f%%", Total_Haste)
end)

Dodge:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Dodge = GetDodgeChance()
	Dodge_Frame.text = string.format("Dodge: %.2f%%", Total_Dodge)
end)

Parry:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Parry = GetParryChance()
	Parry_Frame.text = string.format("Parry: %.2f%%", Total_Parry)
end)

Block:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Block = GetBlockChance()
	Block_Frame.text = string.format("Block: %.2f%%", Total_Block)
end)

Hit:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Hit = GetCombatRatingBonus("8")
	Hit_Frame.text = string.format("Hit Chance: %.2f%%", Total_Hit)
end)

Resilience:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Total_Resilience = GetCombatRatingBonus("17")
	Resilience_Frame.text = string.format("Resilience: -%.2f%%", Total_Resilience)
end)

Melee_AP:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Melee_AP = UnitAttackPower("player")
	Melee_AP_Frame.text = "Melee Attack Power: "..Melee_AP
end)

Melee_Crit:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Melee_Crit = GetCritChance("player")
	Melee_Crit_Frame.text = string.format("Melee Crit: %.2f%%", Melee_Crit)
end)

Expertise:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Expertise = GetCombatRatingBonus("24")
	Expertise_Frame.text = string.format("Expertise: %.2f%%", Expertise)
end)

Armor_Pen:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Armor_Pen = GetCombatRatingBonus("25")
	Armor_Pen_Frame.text = string.format("Armor Penetration: %.2f%%", Armor_Pen)
end)

Range_AP:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Range_AP = UnitRangedAttackPower("player")
	Range_AP_Frame.text = "Range Attack Power: "..Range_AP
end)

Range_Crit:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local Range_Crit = GetRangedCritChance("25")
	Range_Crit_Frame.text = string.format("Range Crit: %.2f%%", Range_Crit)
end)

Fire_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Fire = GetSpellBonusDamage("3")
	Fire_SP_Frame.text = "Fire Dmg: "..SP_Fire
end)

Fire_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Fire_Crit = GetSpellCritChance("3")
	Fire_Crit_Frame.text = string.format("Fire Crit: %.2f%%", SP_Fire_Crit)
end)

Frost_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Frost = GetSpellBonusDamage("5")
	Frost_SP_Frame.text = "Frost Dmg: "..SP_Frost
end)

Frost_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Frost_Crit = GetSpellCritChance("5")
	Frost_Crit_Frame.text = string.format("Frost Crit: %.2f%%", SP_Frost_Crit)
end)

Holy_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Holy = GetSpellBonusDamage("2")
	Holy_SP_Frame.text = "Holy Dmg: "..SP_Holy
end)

Holy_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Holy_Crit = GetSpellCritChance("2")
	Holy_Crit_Frame.text = string.format("Holy Crit: %.2f%%", SP_Holy_Crit)
end)

Shadow_DMG:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Shadow = GetSpellBonusDamage("6")
	Shadow_SP_Frame.text = "Shadow Dmg: "..SP_Shadow
end)

Shadow_CRIT:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0
	local SP_Shadow_Crit = GetSpellCritChance("6")
	Shadow_Crit_Frame.text = string.format("Shadow Crit: %.2f%%", SP_Shadow_Crit)
end)